/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 284 by dpavlin, Tue Dec 13 12:54:24 2011 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
         ls /var/lib/lxc/*/config | cut -d/ -f5  
         exit 1  
 fi  
30    
31  rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  echo "$name rootfs $rootfs"                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
38    
39    lxc_rootfs() {
40            grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56    lxc_status() {
57            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58                    status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`     # 0.7.5
59                    test -z "$status" && status=`lxc-info -n $name | sed -e 's/^.* is //'` # 0.7.2
60                    boot="-"
61                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
62                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
63            done ) | column -t
64    }
65    
66    
67    cleanup_init_scripts() {
68            rootfs=$(lxc_rootfs $1)
69    
70            ls \
71                    $rootfs/etc/rc?.d/*checkroot* \
72                    $rootfs/etc/rc?.d/*umountfs \
73                    $rootfs/etc/rc?.d/*umountroot \
74                    $rootfs/etc/rc?.d/*hwclock* \
75                    $rootfs/etc/rc?.d/*udev* \
76                    $rootfs/etc/rc?.d/*checkfs* \
77            2>/dev/null | xargs -i rm -v {}
78    
79            echo $1 > $rootfs/etc/hostname
80            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
81    }
82    
83    
84    setup_inittab() {
85            rootfs=$(lxc_rootfs $1)
86            remove=$2
87            add=$3
88    
89            # let container respond to kill -SIGPWR
90            inittab=$rootfs/etc/inittab
91            if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
92                    grep -v "$remove" ${inittab} > ${inittab}.new
93                    echo $add >> ${inittab}.new
94                    mv ${inittab}.new ${inittab}
95                    echo "$inittab modified with $add"
96            fi
97    }
98    
 # cleanup init scripts which don't work in containers  
 ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}  
 ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}  
 ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}  
99    
100  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_log() {
101            echo `date +%Y-%m-%dT%H:%M:%S` $*
102    }
103    
104    
105    lxc_kill() {
106            name=$1
107            sig=$2
108    
109            ver=`lxc-version | cut -d: -f2 | sed 's/\.//g'`
110            opts=''
111            test $ver -ge 075 && opts='--'
112    
113            init_pid=`lxc-ps $opts -C init -o pid | grep "^$name" | cut -d" " -f2-`
114            if [ -z "$init_pid" ] ; then
115                    lxc-info -n $name
116                    exit 1
117            fi
118            lxc_log "$name kill $sig $init_pid"
119            /bin/kill $sig $init_pid
120    }
121    
122    lxc_stop() {
123            lxc_log "$name stop"
124            lxc_kill $name -SIGPWR
125            lxc-wait -n $name -s STOPPED
126            lxc_log "$name stoped"
127    #       rm -f /var/lib/lxc/${name}/on_boot
128    }
129    
130    
131    lxc_start() {
132            name=$1
133            rootfs=$(lxc_rootfs $1)
134    
135            if [ ! -e $rootfs ] ; then
136                    echo "ERROR $name rootfs $rootfs not found"
137                    return
138            fi
139    
140            if ! lxc-info -n $name | grep RUNNING ; then
141                    lxc_log "$name start"
142                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
143                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
144                    lxc-start -n $name -o /tmp/${name}.log -d
145                    lxc-wait  -n $name -s RUNNING
146                    lxc-info  -n $name
147                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
148            fi
149    }
150    
151    lxc_watchdog() {
152    name=$1
153    rootfs=$(lxc_rootfs $1)
154    run=$rootfs/var/run
155    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
156    cd $run || echo "can't cd watchdog into $run"
157    
158  while true; do  while true; do
159          # time of 5 minutes on it JUST IN CASE...          tasks=`wc -l < /cgroup/${name}/tasks`
160          vps_utmp=${rootfs}/var/run/utmp          stop_on=1 # init
161          inotifywait -qqt 300 ${vps_utmp}          sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
162          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          if [ "$sulogins" -gt 0 ] ; then
163                    stop_on=`expr $stop_on + $sulogins`
164            fi
165    
166            test -z "$tasks" && exit 1
167            if [ "$tasks" -eq $stop_on ]; then
168    
169                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
170                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
171    
172                  case $runlevel in                  case $runlevel in
173                  N*)                  N*)
174                          # nothing for new boot state                          # nothing for new boot state
175                  ;;                  ;;
176                  ??0)                  ??0|unknown)
177                          echo "$name halt"                          lxc_log "$name halt"
178                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
179                            lxc-wait -n ${name} -s STOPPED
180                          break                          break
181                  ;;                  ;;
182                  ??6)                  ??6)
183                          echo "$name reboot";                          lxc_log "$name reboot";
184                          lxc-stop -n ${name}                          lxc-stop -n ${name}
185                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
186                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
187                  ;;                  ;;
188                  *)                  *)
# Line 54  while true; do Line 191  while true; do
191                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
192                  ;;                  ;;
193                  esac                  esac
194            else
195                    lxc_log "$name $tasks tasks $sulogins console"
196          fi          fi
197    
198            # time of 5 minutes on it JUST IN CASE...
199            inotifywait -qqt 300 utmp
200  done  done
201    
202    lxc_log "$name watchdog exited"
203    
204    }
205    
206    
207    usage() {
208            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
209            exit 3
210    }
211    
212    command_on_lxc() {
213    command=$1
214    shift
215    
216    echo "# $command $1"
217    
218    case "$command" in
219    
220    start)
221            lxc_exists $1
222            cleanup_init_scripts $1
223            setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
224            setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
225            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
226            lxc_start $1
227            # give container 5 seconds to start more than one process
228            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
229            ;;
230    stop|halt)
231            lxc_exists $1
232            lxc_stop $1
233            ;;
234    reload|force-reload|restart|reboot)
235            lxc_kill $1 -SIGINT
236            ;;
237    watchdog)
238            lxc_watchdog $1
239            ;;
240    boot)
241            echo $1 > /var/lib/lxc/$1/on_boot
242            ;;
243    disable)
244            echo -n > /var/lib/lxc/$1/on_boot
245            ;;
246    *)
247            usage
248            ;;
249    
250    esac
251    
252    }
253    
254    command=$1
255    test -z "$command" && usage
256    test "$command" = "status" && lxc_status && exit
257    shift
258    
259    if [ -z "$1" ] ; then
260            ls /var/lib/lxc/*/on_boot | while read path ; do
261                    name=`echo $path | cut -d/ -f5`
262                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
263                            command_on_lxc $command $name
264                    else
265                            echo "# skip $command $name"
266                    fi
267            done
268    else
269            while [ ! -z "$1" ] ; do
270                    command_on_lxc $command $1
271                    shift
272            done
273    fi
274    

Legend:
Removed from v.178  
changed lines
  Added in v.284

  ViewVC Help
Powered by ViewVC 1.1.26